#include "fsxgauges_sp2.h"
#include "dsd_fsx_fuel_dump.h"
#include "LVAR.H"

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "SimConnect.h"

/*
#define TANK_MAIN_RIGHT     0
#define TANK_MAIN_LEFT      1
#define TANK_AUX_RIGHT      2
#define TANK_AUX_LEFT       3
#define TANK_TIP_RIGHT      4
#define TANK_TIP_LEFT       5
#define TANK_CENTER         6
#define TANK_CENTER2        7
#define TANK_CENTER3        8
#define TANK_EXTERNAL1      9
#define TANK_EXTERNAL2      10
*/

#ifdef _DEBUG
FILE* fLog=NULL;
DWORD dwCount = 0;
#endif

static enum CLIENT_EVENT_ID
{
	CLIENT_EVENT_6HZ=64,
	CLIENT_EVENT_FRAME
};

static enum DATA_DEFINE_ID
{
	DATA_DEFINITION_RIGHT_MAIN_QUANTITY,
	DATA_DEFINITION_LEFT_MAIN_QUANTITY,
	DATA_DEFINITION_RIGHT_AUX_QUANTITY,
	DATA_DEFINITION_LEFT_AUX_QUANTITY,
	DATA_DEFINITION_RIGHT_TIP_QUANTITY,
	DATA_DEFINITION_LEFT_TIP_QUANTITY,
	DATA_DEFINITION_CENTER_QUANTITY,
	DATA_DEFINITION_CENTER2_QUANTITY,
	DATA_DEFINITION_CENTER3_QUANTITY,
	DATA_DEFINITION_EXTERNAL1_QUANTITY,
	DATA_DEFINITION_EXTERNAL2_QUANTITY,

	DATA_DEFINITION_FUEL_CAPACITY=128,
	DATA_DEFINITION_FUEL_LEVELS,
};

static enum DATA_REQUEST_ID
{
	DATA_REQUEST_RIGHT_MAIN_QUANTITY,
	DATA_REQUEST_LEFT_MAIN_QUANTITY,
	DATA_REQUEST_RIGHT_AUX_QUANTITY,
	DATA_REQUEST_LEFT_AUX_QUANTITY,
	DATA_REQUEST_RIGHT_TIP_QUANTITY,
	DATA_REQUEST_LEFT_TIP_QUANTITY,
	DATA_REQUEST_CENTER_QUANTITY,
	DATA_REQUEST_CENTER2_QUANTITY,
	DATA_REQUEST_CENTER3_QUANTITY,
	DATA_REQUEST_EXTERNAL1_QUANTITY,
	DATA_REQUEST_EXTERNAL2_QUANTITY,

    DATA_REQUEST_FUEL_CAPACITY=(64*3),
	DATA_REQUEST_FUEL_LEVELS,
};

typedef struct _TANK
{
	LVAR	lv;
	double	capacity;
	double	level;
	double	min_level;
	double	rate;
	double	then;
	double	now;
	int		active;
} _TANK;

_TANK Tank[11];

struct _FuelInfo
{
	double RightMain;
	double LeftMain;
	double RightAux;
	double LeftAux;
	double RightTip;
	double LeftTip;
	double Center;
	double Center2;
	double Center3;
	double External1;
	double External2;
};
_FuelInfo *pFuel;

char GaugeName[MAX_PATH];
double fActiveTank;
double FuelChange = 0.;
double TimeSlice = 0;
double RateGPS;
double fLevel[11];

int j = 0;
int ii;
int iFlip=0;

HINSTANCE ThisModule;
HANDLE hSimConnect;
HRESULT hr;

MODULE_VAR mvSeconds = {ELAPSED_SECONDS};
MODULE_VAR mvWeight = { FUEL_WEGHT_PER_GALLON };

#include "SimConnectProcs.cpp"
void CALLBACK SimConnectProcess(SIMCONNECT_RECV *pData, DWORD cbData, void *pContext)
{
	switch (pData->dwID)
	{
	case SIMCONNECT_RECV_ID_OPEN: //2
	OnRecvOpen((SIMCONNECT_RECV_OPEN*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_EVENT: //4
	OnRecvEvent((SIMCONNECT_RECV_EVENT*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_EVENT_FRAME: //7
//	OnRecvSimObjectFrame( (SIMCONNECT_RECV_EVENT_FRAME*)pData, cbData );
	break;
	case SIMCONNECT_RECV_ID_SIMOBJECT_DATA: //8
	OnRecvSimobjectData((SIMCONNECT_RECV_SIMOBJECT_DATA*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_SIMOBJECT_DATA_BYTYPE: //9
//	OnRecvSimobjectDataByType((SIMCONNECT_RECV_SIMOBJECT_DATA_BYTYPE*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_WEATHER_OBSERVATION: //10
//	OnRecvWeatherObservation((SIMCONNECT_RECV_WEATHER_OBSERVATION*)pData);
	break;

	case SIMCONNECT_RECV_ID_EXCEPTION: //1
//	OnRecvException((SIMCONNECT_RECV_EXCEPTION*)pData, cbData);
	break;
	}
}

void FSAPI	module_init(void)
	{
#ifdef _DEBUG
	if ( !fLog ) fLog = fopen("./FuelDump.log","a");
#endif

	GetModuleFileName( ThisModule, GaugeName, MAX_PATH );
	SimConnect_Open(&hSimConnect, GaugeName, NULL, 0, NULL, SIMCONNECT_OPEN_CONFIGINDEX_LOCAL);
	SimConnect_CallDispatch(hSimConnect, SimConnectProcess, NULL);

	Tank[TANK_MAIN_RIGHT].lv.Register("RATE_TANK_MAIN_RIGHT");
	Tank[TANK_MAIN_LEFT].lv.Register("RATE_TANK_MAIN_LEFT");
	Tank[TANK_AUX_RIGHT].lv.Register("RATE_TANK_AUX_RIGHT");
	Tank[TANK_AUX_LEFT].lv.Register("RATE_TANK_AUX_LEFT");
	Tank[TANK_TIP_RIGHT].lv.Register("RATE_TANK_TIP_RIGHT");
	Tank[TANK_TIP_LEFT].lv.Register("RATE_TANK_TIP_LEFT");
	Tank[TANK_CENTER].lv.Register("RATE_TANK_CENTER");
	Tank[TANK_CENTER2].lv.Register("RATE_TANK_CENTER2");
	Tank[TANK_CENTER3].lv.Register("RATE_TANK_CENTER3");
	Tank[TANK_EXTERNAL1].lv.Register("RATE_TANK_EXTERNAL1");
	Tank[TANK_EXTERNAL2].lv.Register("RATE_TANK_EXTERNAL2");
	}		

void FSAPI	module_deinit(void)
	{
#ifdef _DEBUG
	_fcloseall();
	fLog = NULL;
#endif
	SimConnect_Close(hSimConnect);
	}

BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)	
{
	ThisModule = hDLL;
	return TRUE;
}

#define	GAUGE_NAME  "fuel_dump\0"
#define	GAUGEHDR_VAR_NAME  gaugehdr_fuel_dump
#define	GAUGE_W    10
#include	"dsd_fsx_fuel_dump0.cpp"
#undef	GAUGEHDR_VAR_NAME
#undef	GAUGE_NAME
#undef	GAUGE_W

#define	GAUGE_NAME  "display\0"
#define	GAUGEHDR_VAR_NAME  gaugehdr_fuel_dump_display
#define	GAUGE_W    300
#include	"dsd_fsx_fuel_dump_display.cpp"
#undef	GAUGEHDR_VAR_NAME
#undef	GAUGE_NAME
#undef	GAUGE_W

GAUGESIMPORT	ImportTable =							
{														
	{ 0x0000000F, (PPANELS)NULL },
	{ 0x00000000, NULL }								
};

GAUGESLINKAGE	Linkage =								
{														
	0x00000013,											
	module_init,										
	module_deinit,										
	0,													
	0,
	FS9LINK_VERSION, 
	{
		(&gaugehdr_fuel_dump),
		(&gaugehdr_fuel_dump_display),
		0 
	}
};
